//-----------------------------------------------------------------------------
//Ufw_Csm_Proc_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_csm_proc;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.usim.test.util.*;
import uicc.usim.toolkit.USATEnvelopeHandler;
import uicc.usim.toolkit.USATEnvelopeHandlerSystem;
import uicc.toolkit.*;

public class Ufw_Csm_Proc_1 extends TestToolkitApplet {
	/** number of the actual test case */
	byte	bTestCaseNb		= (byte) 0x00;

	byte	compareBuffer[]	= new byte[100];

	boolean	bRes			= false;


    private byte FORMATTED_SMS[]=new byte[]{
                                (byte)0x40,(byte)0x0B,(byte)0xD0,(byte)0x21,(byte)0x43,(byte)0x65,(byte)0x87,(byte)0x09,
                                (byte)0xF1,(byte)0x7F,(byte)0x16,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,
                                (byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0x02,(byte)0x70,(byte)0x00,(byte)0x00,(byte)0x26,
                                (byte)0x0D,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x50,(byte)0x01,(byte)0x01,
                                (byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x01,(byte)0x01,
                                (byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x02,(byte)0x02,
                                (byte)0x02,(byte)0x02,(byte)0x02,(byte)0x02,(byte)0x02,(byte)0x02,(byte)0x03,(byte)0x03,
                                (byte)0x03,(byte)0x03,(byte)0x03,(byte)0x03,(byte)0x03,(byte)0x03 };


    private byte UNFORMATTED_SMS_NO_UDHI[]=new byte[]{
                                (byte)0x00,(byte)0x0B,(byte)0xD0,(byte)0x21,(byte)0x43,(byte)0x65,(byte)0x87,(byte)0x09,
                                (byte)0xF1,(byte)0x7F,(byte)0x1A,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,
                                (byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0x00,(byte)0x26,(byte)0x0D,(byte)0x00,(byte)0x00,
                                (byte)0x00,(byte)0x00,(byte)0x20,(byte)0x01,(byte)0x01,(byte)0x00,(byte)0x00,(byte)0x00,
                                (byte)0x00,(byte)0x00,(byte)0x00,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,
                                (byte)0x01,(byte)0x01,(byte)0x01,(byte)0x02,(byte)0x02,(byte)0x02,(byte)0x02,(byte)0x02,
                                (byte)0x02,(byte)0x02,(byte)0x02,(byte)0x03,(byte)0x03,(byte)0x03,(byte)0x03,(byte)0x03,
                                (byte)0x03,(byte)0x03,(byte)0x03};
    private byte UNFORMATTED_SMS_WITH_UDHI[]=new byte[]{
                                (byte)0x40,(byte)0x0B,(byte)0xD0,(byte)0x21,(byte)0x43,(byte)0x65,(byte)0x87,(byte)0x09,
                                (byte)0xF1,(byte)0x7F,(byte)0x1A,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,
                                (byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0x00,(byte)0x00,(byte)0x26,(byte)0x0D,(byte)0x00,
                                (byte)0x00,(byte)0x00,(byte)0x00,(byte)0x20,(byte)0x01,(byte)0x01,(byte)0x00,(byte)0x00,
                                (byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,
                                (byte)0x01,(byte)0x01,(byte)0x01,(byte)0x01,(byte)0x02,(byte)0x02,(byte)0x02,(byte)0x02,
                                (byte)0x02,(byte)0x02,(byte)0x02,(byte)0x02,(byte)0x03,(byte)0x03,(byte)0x03,(byte)0x03,
                                (byte)0x03,(byte)0x03,(byte)0x03,(byte)0x03};

	/** list of events */
	short	eventList[]		= new short[] { EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_FORMATTED_SMS_PP_ENV};

	/** device identities */
	byte	DEV_ID[]		= new byte[] { (byte) 0x82, (byte) 0x02, (byte) 0x83, (byte) 0x81 };

	/** address value */
	byte	ADDR[]			= new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00,
                                           (byte) 0x00, (byte) 0x00};


	 /**
	 * @param bArray the array containing installation parameters
	 * @param bOffset the starting offset in bArray
	 * @param bLength the length in bytes of the parameter data in bArray The maximum value of bLength is 127.
	 * @throws ISOException if the install method failed
	 */
	private Ufw_Csm_Proc_1(byte[] bArray, short bOffset, byte bLength) {
		byte aidLen = bArray[bOffset];
		if (aidLen == (byte) 0) {
			register();
		}
        else {
			register(bArray, (short) (bOffset + 1), aidLen);
		}
		//initialize data of the test toolkit applet
		this.init();
		//register events
		obReg.setEventList(eventList,(short)0,(short)(eventList.length));
	}


    /**
	 * Create an instance of the Ufw_Cbs_Mmra_1 Applet
	 * @param bArray the array containing installation parameters
	 * @param bOffset the starting offset in bArray
	 * @param bLength the length in bytes of the parameter data in bArray The maximum value of bLength is 127.
	 * @throws ISOException if the install method failed
	 * @see javacard.framework.Applet
	 */
	public static void install(byte[] bArray, short bOffset, byte bLength) throws ISOException {
		Ufw_Csm_Proc_1 applet = new Ufw_Csm_Proc_1(bArray,bOffset,bLength);
	}

	public void processToolkit(short event){
		bRes=false;
		bTestCaseNb+=(byte)0x01;
        
		switch (event){

			case EVENT_FORMATTED_SMS_PP_ENV:
				if (bTestCaseNb==(byte)0x04){
					//tc 4 is triggered, test successful
					bRes=true;
				}
				//for all other test cases sms content will be checked
				else if(verifyDeviceID() && verifyAddress() && verifyFormattedSMS()){
						bRes=true;
				}
				this.reportTestOutcome(bTestCaseNb,bRes);
				break;

			case EVENT_UNFORMATTED_SMS_PP_ENV:
				if (bTestCaseNb==(byte)0x08){
					//tc 8 is triggered, test successful
					bRes=true;
				}
				//for all other test cases sms content will be checked
				else if(verifyDeviceID() && verifyAddress() && verifyUnformattedSMS()){
					bRes=true;
				}
				this.reportTestOutcome(bTestCaseNb,bRes);
				break;

			default:
				//applet should not be triggered
				this.reportTestOutcome(bTestCaseNb,bRes);
				break;
		}
	}


	/**
	 * Checks if the tlv device id available and the contend is correct
	 * @return true if contend ok. otherwise false
	 */
	private boolean verifyDeviceID(){
		USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
		if (envHdlr.findTLV((byte)0x82,(byte)0x01)!=TLV_NOT_FOUND){
			if(envHdlr.compareValue((short)0,DEV_ID,(short)2,(short)2)==(short)0){
				return true;
			}
			else return false;
		}
		else return false;
	}

	/**
	 * Checks if the tlv address available and the contend is correct.
	 * @return true if contend is correct. Otherwise false.
	 */
	private boolean verifyAddress(){
		USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
		if (envHdlr.findTLV((byte)0x86,(byte)0x01)!=TLV_NOT_FOUND){
			if(envHdlr.compareValue((short)0,ADDR,(short)0,(short)ADDR.length)==(short)0){
				return true;
			}
			else return false;
		}
		else return false;
	}


	/**
	 * Verifies the complete formatted sms .
	 * No concatination concatination control header should be present and the user
	 * data should be resembled in correct order.
	 * @return true if the formatted sms is correct. Otherwise false.
	 */
	private boolean verifyFormattedSMS(){
		USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
		//find the sms tpdu tag
		if (envHdlr.findTLV((byte)0x0B,(byte)0x01) != TLV_NOT_FOUND){
			//check the complete content of the sms
			if ((envHdlr.compareValue((short)0,FORMATTED_SMS,(short)0,(short)0x12)==0) &&
                (envHdlr.compareValue((short)0x13,FORMATTED_SMS,(short)0x13,(short)0x2B)==0)) {
				return true;
			}
		}
		return false;
	}



	/**
	 * Verifies the complete formatted sms .
	 * No concatination concatination control header should be present and the user
	 * data should be resembled in correct order.
	 * @return true if the formatted sms is correct. Otherwise false.
	 */
	private boolean verifyUnformattedSMS(){
		USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
		//find the sms tpdu tag
		if (envHdlr.findTLV((byte)0x0B,(byte)0x01) != TLV_NOT_FOUND){
			//check the complete content of the sms
			if ((envHdlr.compareValue((short)0,UNFORMATTED_SMS_NO_UDHI,(short)0,(short)0x12)==0) &&
                (envHdlr.compareValue((short)0x13,UNFORMATTED_SMS_NO_UDHI,(short)0x13,(short)0x28)==0)) 
            {
				return true;
			}
			else if ((envHdlr.compareValue((short)0,UNFORMATTED_SMS_WITH_UDHI,(short)0,(short)0x12)==0) &&
                (envHdlr.compareValue((short)0x13,UNFORMATTED_SMS_WITH_UDHI,(short)0x13,(short)0x29)==0)) 
            {
                return true;
			}
		}
		return false;
	}


}












