//-----------------------------------------------------------------------------
//    Api_2_Tkr_Sevt_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_tkr_sevt;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;

/**
 * Test Area : usim.toolkit...
 *
 * Applet is triggered on Install (Install)
 *
 *
 */

public class Api_2_Tkr_Sevt_2 extends TestToolkitApplet {
    
    private boolean firstTrigger = true;
    
    /**
     * Constructor of the applet
     */
    public Api_2_Tkr_Sevt_2() {
    }
    
    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        
        
        
        // Create a new applet instance.
        Api_2_Tkr_Sevt_2 thisApplet = new Api_2_Tkr_Sevt_2();
        
        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet.
        thisApplet.init();
        
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        
    }
    
    
    public void processToolkit(short event) {
        
        
        boolean bRes = false;
        byte    bTestCaseNb = (byte)0;
        
        if (event == EVENT_FORMATTED_SMS_PP_ENV){
            
            // --------------------------------------------------------------------------
            //  Test Case 4 : Applet2 registers to EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
            //  but it is already assigned
            // --------------------------------------------------------------------------
            // --------------------------------------------------------------------------
            //  Test Case 5 : Applet2 registers to EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
            //  but it is already assigned to another applet in not selectable state
            // --------------------------------------------------------------------------
            
            if (firstTrigger) {
                bTestCaseNb = (byte)1;
                firstTrigger = (boolean)false;
            } else {
                bTestCaseNb = (byte)2;
            }
            
            try {
                // ToolkitException.EVENT_ALREADY_REGISTERED shall be thrown
                obReg.setEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);
            } catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.EVENT_ALREADY_REGISTERED);
            } catch (Exception e) {
                bRes = false;
            }
            reportTestOutcome(bTestCaseNb, bRes) ;
            
        }
        
    }
    
}