//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//----------------------------------------------------------------------------- 
package uicc.usim.test.usatframework.ufw_mha_erhd;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;


public class Ufw_Mha_Erhd_2 extends TestToolkitApplet {
    /** result of specific testcase */
    boolean         bRes    = false;
    /** number of testcase */
    byte          testCaseNb  = (byte) 0x00;
    private byte[] sendData= {(byte)0x22, (byte)0x22, (byte)0x22, (byte)0x22, (byte)0x22, 
                              (byte)0x22, (byte)0x22, (byte)0x22, (byte)0x22, (byte)0x22};      
    /**
     */
    private Ufw_Mha_Erhd_2 () {
  
    }
  
    public static void install(byte[] bArray, short bOffset, byte bLength) {
 
         
        // Create a new applet instance.
        Ufw_Mha_Erhd_2 thisApplet = new Ufw_Mha_Erhd_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
              
        //- Applet registration     
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
    }
    
  
    public void processToolkit(short event) throws ToolkitException {
              
        bRes=false;
        if (event == EVENT_UNFORMATTED_SMS_PP_ENV) {
            //Test case 6
            switch(testCaseNb) {
            case (byte)0x00:
            case (byte)0x01:
                try {
                    EnvelopeResponseHandler envRespHdlr=EnvelopeResponseHandlerSystem.getTheHandler();
                    bRes=false;
                }
                catch(ToolkitException e) {
                    bRes = (e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE);
                }
                catch(Exception e) {
                    bRes=false;
                }
                testCaseNb++;
                reportTestOutcome(testCaseNb,bRes);
                break;
            //Test case 8
            case (byte)0x02:                
                try {
                    EnvelopeResponseHandler envRespHdlr =EnvelopeResponseHandlerSystem.getTheHandler();
                    envRespHdlr.appendArray(sendData,(short)0x00,(short)sendData.length);                    
                    envRespHdlr.post(true);                    
                    bRes=true;
                }
                catch(Exception e) {
                    bRes=false;
                }
                testCaseNb++;
                reportTestOutcome(testCaseNb,bRes);
                break;
            }
        }
    }

}